## cataclysm-dda 0.5-maemo1

=== Makefile ===
# Platforms:
# Linux native
#   (don't need to do anything)
# Linux 64-bit
#   make NATIVE=linux64
# Linux 32-bit
#   make NATIVE=linux32
# Linux cross-compile to Win32
#   make CROSS=i686-pc-mingw32-
#   or make CROSS=i586-mingw32msvc-
#   or whichever prefix your crosscompiler uses
#      as long as its name contains mingw32
# Win32
#   Run: make NATIVE=win32
# OS X
#   Run: make NATIVE=osx

# Build types:
# Debug (no optimizations)
#  Default
# Release (turn on optimizations)
#  make RELEASE=1


# comment these to toggle them as one sees fit.
# WARNINGS will spam hundreds of warnings, mostly safe, if turned on
# DEBUG is best turned on if you plan to debug in gdb -- please do!
# PROFILE is for use with gprof or a similar program -- don't bother generally
WARNINGS = -Wall -Wextra -Wno-switch -Wno-sign-compare -Wno-missing-braces -Wno-unused-parameter
# Uncomment below to disable warnings
#WARNINGS = -w
DEBUG = -g
#PROFILE = -pg
#OTHERS = -O3
#DEFINES = -DNDEBUG

# Disable debug. Comment this out to get logging.
#DEFINES = -DENABLE_LOGGING

# Limit debug to level. Comment out all for all levels.
#DEFINES += -DDEBUG_INFO
#DEFINES += -DDEBUG_WARNING
#DEFINES += -DDEBUG_ERROR
#DEFINES += -DDEBUG_PEDANTIC_INFO

# Limit debug to section. Comment out all for all levels.
#DEFINES += -DDEBUG_ENABLE_MAIN
#DEFINES += -DDEBUG_ENABLE_MAP
#DEFINES += -DDEBUG_ENABLE_MAP_GEN
#DEFINES += -DDEBUG_ENABLE_GAME


VERSION = 0.5


TARGET = cataclysm
W32TARGET = cataclysm.exe
BINDIST_DIR = bindist

ODIR = obj
W32ODIR = objwin
DDIR = .deps

OS  = $(shell uname -o)
CXX = $(CROSS)g++
LD  = $(CROSS)g++

# enable optimizations. slow to build
ifdef RELEASE
  OTHERS += -O3
  DEBUG =
endif

CXXFLAGS += $(WARNINGS) $(DEBUG) $(PROFILE) $(OTHERS) -MMD

BINDIST_EXTRAS = README data cataclysm-launcher
BINDIST    = cataclysmdda-$(VERSION).tar.gz
W32BINDIST = cataclysmdda-$(VERSION).zip
BINDIST_CMD    = tar -czvf $(BINDIST) $(BINDIST_DIR)
W32BINDIST_CMD = zip -r $(W32BINDIST) $(BINDIST_DIR)

# is this section even being used anymore?
# SOMEBODY PLEASE CHECK
#ifeq ($(OS), Msys)
#  LDFLAGS = -static -lpdcurses
#else
#  LDFLAGS += -lncurses
#endif

# Check if called without a special build target
ifeq ($(NATIVE),)
  ifeq ($(CROSS),)
    TARGETSYSTEM=LINUX
  endif
endif

# Linux 64-bit
ifeq ($(NATIVE), linux64)
  CXXFLAGS += -m64
  TARGETSYSTEM=LINUX
else
  # Linux 32-bit
  ifeq ($(NATIVE), linux32)
    CXXFLAGS += -m32
    TARGETSYSTEM=LINUX
  endif
endif

# OSX
ifeq ($(NATIVE), osx)
  CXXFLAGS += -mmacosx-version-min=10.6
  TARGETSYSTEM=LINUX
endif

# Win32 (mingw32?)
ifeq ($(NATIVE), win32)
  TARGETSYSTEM=WINDOWS
endif

# MXE cross-compile to win32
ifneq (,$(findstring mingw32,$(CROSS)))
  TARGETSYSTEM=WINDOWS
endif

# Global settings for Linux targets
ifeq ($(TARGETSYSTEM),LINUX)
  LDFLAGS += -lncurses
endif

# Global settings for Windows targets
ifeq ($(TARGETSYSTEM),WINDOWS)
  TARGET = $(W32TARGET)
  BINDIST = $(W32BINDIST)
  BINDIST_CMD = $(W32BINDIST_CMD)
  ODIR = $(W32ODIR)
  LDFLAGS += -static -lgdi32 
  W32FLAGS += -Wl,-stack,12000000,-subsystem,windows
endif

SOURCES = $(wildcard *.cpp)
HEADERS = $(wildcard *.h)
_OBJS = $(SOURCES:.cpp=.o)
OBJS = $(patsubst %,$(ODIR)/%,$(_OBJS))

all: version $(TARGET)
	@

$(TARGET): $(ODIR) $(DDIR) $(OBJS)
	$(LD) $(W32FLAGS) -o $(TARGET) $(DEFINES) $(CXXFLAGS) \
          $(OBJS) $(LDFLAGS)

.PHONY: version
version:
	@( VERSION_STRING=$(VERSION) ; \
            [ -e ".git" ] && GITVERSION=$$( git describe --tags --always --match "[0-9]*.[0-9]*" ) && VERSION_STRING=$$GITVERSION ; \
            [ -e "version.h" ] && OLDVERSION=$$(grep VERSION version.h|cut -d '"' -f2) ; \
            if [ "x$$VERSION_STRING" != "x$$OLDVERSION" ]; then echo "#define VERSION \"$$VERSION_STRING\"" | tee version.h ; fi \
         )

$(ODIR):
	mkdir $(ODIR)

$(DDIR):
	@mkdir $(DDIR)

$(ODIR)/%.o: %.cpp
	$(CXX) $(DEFINES) $(CXXFLAGS) -c $< -o $@

version.cpp: version

clean: clean-tests
	rm -f $(TARGET) $(W32TARGET) $(ODIR)/*.o $(ODIR)/*.d $(W32ODIR)/*.o $(W32BINDIST) \
	$(BINDIST)
	rm -rf $(BINDIST_DIR)
	rm -f version.h

bindist: $(BINDIST)

$(BINDIST): $(TARGET) $(BINDIST_EXTRAS)
	rm -rf $(BINDIST_DIR)
	mkdir -p $(BINDIST_DIR)
	cp -R $(TARGET) $(BINDIST_EXTRAS) $(BINDIST_DIR)
	$(BINDIST_CMD)

export ODIR _OBJS LDFLAGS CXX W32FLAGS DEFINES CXXFLAGS

ctags: $(SOURCES) $(HEADERS)
	ctags $(SOURCES) $(HEADERS)

etags: $(SOURCES) $(HEADERS)
	etags $(SOURCES) $(HEADERS)

tests: $(ODIR) $(DDIR) $(OBJS)
	$(MAKE) -C tests

check: tests
	$(MAKE) -C tests check

clean-tests:
	$(MAKE) -C tests clean

.PHONY: tests check ctags etags clean-tests

-include $(SOURCES:%.cpp=$(DEPDIR)/%.P)
-include ${OBJS:.o=.d}

=== debian/changelog ===
cataclysm-dda (0.5-maemo1) unstable; urgency=low

  * New upstream code (2f4a2110655576c1d29575be90098ae9ea575e03)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 18 Jun 2013 17:11:40 +0200

cataclysm-dda (0.2-maemo1) unstable; urgency=low

  * New upstream code (Forked)
  * Menu icon
  * (uses /opt/cataclysm/save no code modifications for that)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Wed, 06 Mar 2013 21:58:40 +0200

cataclysm (0.0.5-maemo1) unstable; urgency=low

  * New upstream code
  * Menu icon
  * (uses /opt/cataclysm/save no code modifications for that)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Wed, 21 Mar 2012 21:58:40 +0200

cataclysm (0.0.4-maemo1) unstable; urgency=low

  * New upstream code
  * Menu icon
  * saves to /home/user/.cataclysm/

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 22 Nov 2011 09:37:40 +0200

cataclysm (0.0.3-maemo1) unstable; urgency=low

  * New upstream
  * Menu icon
  * saves to /home/user/.cataclysm/

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 18 Oct 2011 13:37:40 +0200

cataclysm (0.0.2-maemo1) unstable; urgency=low

  * New upstream
  * Menu icon
  * saves to /home/user/.cataclysm/

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Mon, 15 Jul 2011 21:53:40 +0200

cataclysm (0.0.1-maemo1) unstable; urgency=low

  * Initial release

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu, 12 Jul 2011 14:53:40 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif


configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp

build: build-stamp
build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	make

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	make clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs


	#folders
	install -d ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/data
	install -d ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/save

	#binary
	install ${CURDIR}/cataclysm ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/
	#data
	cp -r ${CURDIR}/data ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/

	#menu and icon and starter
	install -d  ${CURDIR}/debian/cataclysm-dda/usr/share/icons/hicolor/64x64/hildon
	install ${CURDIR}/debian/cataclysm-dda.png     ${CURDIR}/debian/cataclysm-dda/usr/share/icons/hicolor/64x64/hildon

	#there must be desktop-file and two launcher. desktop file can't use any parameters
	# .desktop calls /usr/bin/cataclysm-dda.sh
	# /usr/bin/cataclysm-dda.sh starts osso-xterm and gives opt/cataclysm-dda/cataclysm-launcher.sh as parameter (-e)
	# cataclysm-launcher.sh uses cd X ; ./cataclysm (binary must be called near data-files)

	#desktop
	install -d ${CURDIR}/debian/cataclysm-dda/usr/share/applications/hildon
	install ${CURDIR}/debian/cataclysm-dda.desktop ${CURDIR}/debian/cataclysm-dda/usr/share/applications/hildon

	#launcher 1
	install -d ${CURDIR}/debian/cataclysm-dda/usr/bin
	install ${CURDIR}/debian/cataclysm-dda.sh ${CURDIR}/debian/cataclysm-dda/usr/bin

	#launcher 2
	install ${CURDIR}/debian/cataclysm-launcher.sh ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## cataclysm-dda 0.5-maemo2

=== tests/Makefile ===
# Make any tests, and possibly run them.
# A selection of variables are exported from the master Makefile
# libtap.so and tap.h must be in the local directory or on the system path.

# ODIR is realative, so we can use the one from the main Makefile

# As each test will have a main function we need to handle this file by file
TEST_SOURCES = $(wildcard *_test.cpp)
TEST_OBJS = $(TEST_SOURCES:%.cpp=$(ODIR)/%.o)
TESTS = $(TEST_SOURCES:.cpp=)

# Brute force solution, relative paths to EVERY .o file
SOURCE_OBJS = $(patsubst %,../$(ODIR)/%,$(filter-out main.o,$(_OBJS)))

LDFLAGS += -L. -ltap -lpthread

CXXFLAGS += -I..

LD := $(CROSS)g++

tests: $(TESTS)

%_test: $(ODIR) $(DDIR) $(SOURCE_OBJS) $(TEST_OBJS)
	$(LD) $(W32FLAGS) -o $@ $(DEFINES) $(ODIR)/$@.o $(SOURCE_OBJS) $(CXXFLAGS) $(LDFLAGS)

check: $(TESTS)
	LD_LIBRARY_PATH=/usr/local/lib ./$?

clean:
	rm -f $(TESTS) *.d $(ODIR)/*.o $(ODIR)/*.d

$(ODIR):
	mkdir $(ODIR)

$(DDIR):
	@mkdir $(DDIR)

$(ODIR)/%.o: %.cpp
	$(CXX) $(DEFINES) $(CXXFLAGS) -c $< -o $@

.PHONY: clean

=== debian/changelog ===
cataclysm-dda (0.5-maemo2) unstable; urgency=low

  * Icon
  * default keys

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Wed, 19 Jun 2013 13:34:40 +0200

=== debian/control ===
Source: cataclysm-dda
Section: user/games
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com> 
Build-Depends: debhelper (>= 5.0.42), libncurses5-dev
Standards-Version: 3.8.1
Homepage: https://github.com/TheDarklingWolf/Cataclysm-DDA

Package: cataclysm-dda
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Post-apocalyptic roguelike

=== debian/rules ===
--- 
+++ 
@@ -60,6 +60,7 @@
 	install ${CURDIR}/cataclysm ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/
 	#data
 	cp -r ${CURDIR}/data ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/
+	cp ${CURDIR}/debian/keymap.txt ${CURDIR}/debian/cataclysm-dda/opt/cataclysm-dda/
 
 	#menu and icon and starter
 	install -d  ${CURDIR}/debian/cataclysm-dda/usr/share/icons/hicolor/64x64/hildon
